import { Component } from "react";

export default class Input extends Component {
	componentDidMount() {
		const { id } = this.props;
		const input = document.getElementById(id);

		if (input) {
			input.addEventListener("input", this.mask);
		}
	}

	componentWillUnmount() {
		const { id } = this.props;
		const input = document.getElementById(id);

		if (input) {
			input.removeEventListener("input", this.mask);
		}
	}

	mask = e => {
		const { value } = e.target;
		if (!value) {
			return value;
		}

		const onlyNums = value.replace(/[^\d]/g, "");
		if (onlyNums.length <= 3) {
			return (e.target.value = onlyNums);
		}
		if (onlyNums.length <= 7) {
			return (e.target.value = `${onlyNums.slice(0, 3)}-${onlyNums.slice(3)}`);
		}
		return (e.target.value = `${onlyNums.slice(0, 3)}-${onlyNums.slice(3, 6)}-${onlyNums.slice(6, 10)}`);
	};

	render() {
		return this.props.children;
	}
}
